export function basicSuggestionsProvider(values, maxSuggest = 20) {
    return (query) => values.map(value => typeof value == "string" ? ({ value: value, label: value }) : value)
        .filter(v => v.label.toLowerCase().includes(query.toLowerCase()))
        .sort((a, b) => alphabeticalSortWithPriorToStartWithQuery(a.label, b.label, query))
        .slice(0, maxSuggest);
}
function alphabeticalSortWithPriorToStartWithQuery(a, b, query) {
    const lowerA = a.toLowerCase();
    const lowerB = b.toLowerCase();
    const lowerQuery = query.toLowerCase();
    if (lowerA.startsWith(lowerQuery) && !lowerB.includes(lowerQuery)) {
        return -1;
    }
    if (lowerB.startsWith(lowerQuery) && !lowerA.startsWith(lowerQuery)) {
        return 1;
    }
    return lowerA.localeCompare(lowerB);
}
