var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { FtLitElement } from "@fluid-topics/ft-wc-utils";
import { html, nothing } from "lit";
import { property, query, queryAssignedNodes } from "lit/decorators.js";
import { FtRipple } from "@fluid-topics/ft-ripple";
import { FtTypography } from "@fluid-topics/ft-typography";
import { suggestionStyles } from "./ft-text-field-suggestion.styles";
import { FtIcon } from "@fluid-topics/ft-icon";
import { classMap } from "lit/directives/class-map.js";
export class SuggestionSelectedEvent extends CustomEvent {
    constructor(value) {
        super("suggestion-selected", { detail: value, bubbles: true, composed: true });
    }
}
class FtTextFieldSuggestion extends FtLitElement {
    render() {
        const classes = {
            "ft-text-field-suggestion": true,
            "ft-text-field-suggestion--with-helper": !!this.helper
        };
        return html `
            <div class=${classMap(classes)}
                 tabindex="-1"
                 @keydown=${this.onKeyDown}
                 @click=${this.confirmSuggestion}>
                <ft-ripple></ft-ripple>
                ${this.helper ? html `
                    <ft-typography class="ft-text-field-suggestion--helper-text" variant="caption">
                        ${this.helper}
                    </ft-typography>` : nothing}
                <ft-typography part="label"
                               variant="body1"
                               class="ft-text-field-suggestion--label">
                    <slot></slot>
                </ft-typography>
            </div>
        `;
    }
    focus(options) {
        var _a;
        (_a = this.container) === null || _a === void 0 ? void 0 : _a.focus(options);
    }
    click() {
        var _a;
        (_a = this.container) === null || _a === void 0 ? void 0 : _a.click();
    }
    confirmSuggestion() {
        this.dispatchEvent(new SuggestionSelectedEvent(this.getValue()));
    }
    getValue() {
        return this.value || this.textContent;
    }
    get textContent() {
        return this.assignedNodes.map(n => n.textContent).join("").trim();
    }
    onKeyDown(event) {
        if (["Enter", " "].includes(event.key)) {
            event.preventDefault();
            event.stopPropagation();
            this.confirmSuggestion();
        }
    }
}
FtTextFieldSuggestion.elementDefinitions = {
    "ft-ripple": FtRipple,
    "ft-typography": FtTypography,
    "ft-icon": FtIcon,
};
FtTextFieldSuggestion.styles = suggestionStyles;
__decorate([
    property()
], FtTextFieldSuggestion.prototype, "value", void 0);
__decorate([
    property()
], FtTextFieldSuggestion.prototype, "helper", void 0);
__decorate([
    query(".ft-text-field-suggestion")
], FtTextFieldSuggestion.prototype, "container", void 0);
__decorate([
    queryAssignedNodes()
], FtTextFieldSuggestion.prototype, "assignedNodes", void 0);
export { FtTextFieldSuggestion };
