import { PropertyValues } from "lit";
import { ElementDefinitionsMap, FtLitElement } from "@fluid-topics/ft-wc-utils";
import { FtTextFieldProperties } from "./ft-text-field.properties";
import { FtTextFieldSuggestion } from "./ft-text-field-suggestion";
import { FtTextFieldSuggestionDefinition } from "./models";
declare const FtTextField_base: import("@fluid-topics/ft-wc-utils").FtFormComponentType<typeof FtLitElement>;
export declare class FtTextField extends FtTextField_base implements FtTextFieldProperties {
    static elementDefinitions: ElementDefinitionsMap;
    static styles: import("lit").CSSResult[];
    label?: string;
    private _value;
    get value(): string;
    set value(value: string);
    private setInternalValue;
    dispatchedValue: string;
    helper?: string;
    suggestionsHelper?: string;
    outlined: boolean;
    disabled: boolean;
    error: boolean;
    fixedMenuPosition: boolean;
    prefix: string | null;
    icon?: string;
    name?: string;
    type?: string;
    passwordHiddenIcon: string;
    passwordRevealedIcon: string;
    iconVariant?: string;
    filterSuggestions: boolean;
    maxLength?: number;
    password: boolean;
    autocomplete?: string;
    suggestionsProvider?: (query: string) => FtTextFieldSuggestionDefinition[] | Promise<FtTextFieldSuggestionDefinition[]>;
    focused: boolean;
    hidePassword: boolean;
    hideSuggestions: boolean;
    visibleSuggestions: FtTextFieldSuggestion[];
    providedSuggestions: FtTextFieldSuggestionDefinition[];
    mainPanel?: HTMLElement;
    input?: HTMLInputElement;
    newValueSuggestion?: FtTextFieldSuggestion;
    suggestionsContainer?: HTMLElement;
    providedSuggestionsInDom: FtTextFieldSuggestion[];
    slottedSuggestions: FtTextFieldSuggestion[];
    focus(): void;
    protected render(): import("lit-html").TemplateResult<1>;
    private resolveInputType;
    private renderSuggestions;
    private renderPasswordIcon;
    private renderIcon;
    protected update(props: PropertyValues): void;
    private updateSuggestions;
    private filterSuggestionsIfNeeded;
    protected contentAvailableCallback(props: PropertyValues): void;
    private watchAutofillInterval?;
    private setupWatchAutofill;
    private clearWatchAutofill;
    connectedCallback(): void;
    disconnectedCallback(): void;
    setValue(newValue: string, fireChangeEvent?: boolean): void;
    private handleInput;
    private handleClick;
    private handleKeyboardNavigation;
    private onSuggestionSelected;
    private onFocus;
    private onMainPanelBlur;
    private togglePasswordVisibility;
    private isPasswordField;
    private setSuggestionPosition;
    private suggestionsShouldBeDisplayed;
}
export {};
